package AssetEntries::Tags;

use strict;

sub _hdlr_asset_entries {
    my ( $ctx, $args, $cond ) = @_;
    my $asset = $ctx->stash('asset')
        or return $ctx->_no_assets_error();
    my $builder = $ctx->stash('builder');
    my $tokens  = $ctx->stash('tokens');
    my $res     = '';
    my $glue    = $args->{glue};

    my ( $terms, $arg );
    $terms->{'status'} = MT::Entry::RELEASE();
    $arg->{'sort'} = $args->{sort_by} || 'title';
    $arg->{'direction'}
        = lc( $args->{sort_order} || '' ) eq 'descend' ? 'descend' : 'ascend';
    $arg->{'join'} = MT::ObjectAsset->join_on(
                      'object_id',
                      {   object_ds => 'entry',
                          asset_id => $asset->id
                      });
    $arg->{'limit'} = $args->{lastn};

    require MT::ObjectAsset;
    my $entries;
    @$entries = MT::Entry->load( $terms, $arg );

    my $vars = $ctx->{__stash}{vars} ||= {};
    my $n = $args->{lastn};
    my $i = 0;
    for my $entry (@$entries) {
        local $ctx->{__stash}->{entry} = $entry;
        local $vars->{__first__}   = !$i;
        local $vars->{__last__}    = !defined $$entries[ $i + 1 ];
        local $vars->{__odd__}     = ( $i % 2 ) == 0;
        local $vars->{__even__}    = ( $i % 2 ) == 1;
        local $vars->{__counter__} = $i + 1;

        defined( my $out = $builder->build( $ctx, $tokens, $cond ) )
            or return $ctx->error( $builder->errstr );
        $res .= $glue if defined $glue && length($res) && length($out);
        $res .= $out;
        $i++;
    }
    $res;
}

1;
